# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module 20q
##   Ce module dfinit le plug-in 20q :
##   Interface vers le robot  devinettes "20 questions"
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from coinlib.parsers import zapEntities
from coinlib.persistants import Identity

import string, re, urllib
from random import randrange, choice

regexp = "20[qQ][<]\s*([?]|[0-9]+)"

def build_plugins(pycc):
  return { \
    '20q': Bot20q(pycc, "20questions", "20 questions")
  }

class Bot20q(Plugin):
  
  def init(self):
    self.bot_server = "y.20q.net"
    self.bot_url = "/anon-fr"
    self.session = ""
    self.answers = {}
    # self.getcookie()
  
  def newgame(self):
    try:
      f = open_url(self.bot_server, self.bot_url, self.pycc.options)
      #self.cookie = f.info().getheader('Set-Cookie').split(";")[0]
      res = f.read()
      f.close()
      start = res.find('<form method=post action="/anon-fr?') + 35
      end = res.find('"', start)
      self.session = res[start:end]
      print "### 20Q session:", self.session
    except:
      self.error = "Impossible de recuperer la session de 20q"
      print "### 20Q", self.error
      return
    try:
      query = urllib.urlencode({'sex': '77', 'ccode': '21333', 'age': '42'})
      f = open_url(self.bot_server, self.bot_url+"?"+self.session, self.pycc.options, data=query)
      res = f.read()
      f.close()
      start = res.find("<big><b>Q") + 8
      end = res.find("</b></big>", start)
      questions = res[start:end]
      print "### 20Q questions part", questions
    except:
      self.error = "Impossible de demarrer un jeu"
      print "### 20Q", self.error
      return
    return unicode("Pensez  un objet et l'intelligence artificielle essaiera de deviner  quoi vous pensez en posant des questions simples. ", "iso-8859-1") + self.parse_questions(questions)
  
  def parse_questions(self, text):
    self.answers = {}
    res = ""
    start = 0
    end = text.find('<a href="/anon-fr?')
    cpt = 1
    while end > start:
      res += text[start:end]
      endsess = text.find('"', end+12)
      self.answers[cpt] = text[end+9:endsess]
      res += " <b>%s.</b> " % cpt
      start = text.find(">", end)
      end = text.find("</a>", start)
      res += text[start+1:end]
      start = end + 4
      end = text.find('<a href="/anon-fr?', start)
      cpt += 1
    res += text[start:]
    res = res.replace("&nbsp;", " ")
    res = res.replace("<br>", " ")
    try:
      return unicode(res, "iso-8859-1")
    except:
      print "### 20Q unicode passe pas"
      return res
  
  def process(self, bouchot, context, post=None):
    text = post.message
    if not self.session or not self.answers:
      topost = self.newgame()
      if not topost:
        print "### 20Q: n'a pas pu commencer une partie"
        return
    else:
      text = text[text.find('<')+1:]
      try:
        choice = int(text.split()[0])
        urlchoice = self.answers[choice]
        print "### 20Q choix:", choice, "url:", urlchoice
      except:
        print "### 20Q invocation incorrecte"
        return
      try:
        f = open_url(self.bot_server, urlchoice, self.pycc.options)
        res = f.read()
        f.close()
        #print "### 20Q response"
        #print res
        #end = res.find("<FORM name=f action", 0)
        #print "### ALICE", end
        start = res.find("<h2>Vous avez gagn")
        if start > 0:
          self.session = ""
          topost = ur"<i>OK j'abandonne... vous avez gagn</i>"
        else:
          start = res.find("<h2>20Q a")
          if start > 0:
            self.session = ""
            end = res.find("</h2>", start)
            topost = "<i>"+res[start+4:end]+"</i> "
            start = res.find("<big><b>", end)
            end = res.find("<h2>")
            topost += res[start+5:end]
            topost = unicode(topost, "iso-8859-1")
          else:
            start = res.find("<big><b>Q") + 8
            end = res.find("</b></big>", start)
            questions = res[start:end]
            topost = self.parse_questions(questions)
      except:
        self.error = "Erreur rseau ou du serveur 20Q"
        print "### 20Q", self.error
        return
      print "### 20Q", repr(topost)
    # Postage de la rponse
    try:
      topost = (unicode(post.dispTimeRef() + " [20Q] ") + topost).encode(bouchot.trib.options.val('encoding'))
    except:
      topost = post.dispTimeRef()+' [20Q] '+repr(topost)
    try:
      print "### 20Q poste:", repr(topost)
      bouchot.trib.poster(topost, 1, Identity(login="20Q", ua="20Q"))
    except:
      self.error = "Impossible de poster dans le bouchot %s" % bouchot.name
      print "### 20Q", self.error
