# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module Eliza
##   Ce module dfinit le plug-in Eliza (psy  la emacs)
##   Egalement, une interface pour A.L.I.C.E. ainsi que Cybelle
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from coinlib.parsers import zapEntities
from coinlib.persistants import Identity

import string, re, urllib
from random import randrange, choice

def build_plugins(pycc):
  return { \
    'eliza': Eliza(pycc, "Eliza", "Un bot-psy genre emacs doctor"),
    'alice': Alice(pycc, "Alice", "Un bot conversationnel (www.alice.org)"),
    'cybelle': Cybelle(pycc, "Cybelle", "Un bot conversationnel (www.agentland.com)")
  }

class Eliza(Plugin):
  
  def process(self, bouchot, context, post=None):
    try:
      text = post.message
      query = urllib.urlencode({'Entry1': text[text.find('<'):]})
      f = open_url("www-ai.ijs.si", "/cgi-bin/eliza/eliza_script", self.pycc.options, data=query)
      res = f.read()
      f.close()
      start = res.find("<strong>Eliza:</strong>") + 24
      end = res.find("<form", start) - 1
    except:
      self.error = "Erreur rseau ou du serveur Eliza"
      print "### ELIZA", self.error
      return
    try:
      topost = unicode(res[start.end]).encode(bouchot.trib.options.val('encoding'))
    except:
      topost = res[start:end]
    try:
      bouchot.trib.poster("%s %s" % (post.dispTimeRef(), topost), 1, Identity(login="Eliza", ua="Eliza"))
    except:
      self.error = "Impossible de poster dans le bouchot %s" % bouchot.name
      print "### ELIZA", self.error

class Alice(Plugin):
  
  def init(self):
    self.bot_server = "www.pandorabots.com"
    self.bot_url = "/pandora/talk?botid=f5d922d97e345aa1&skin=custom_input"
    self.cookie = ""
    # self.getcookie()
  
  def getcookie(self):
    try:
      f = open_url(self.bot_server, self.bot_url, self.pycc.options)
      self.cookie = f.info().getheader('Set-Cookie').split(";")[0]
      print f.read()
      print "### ALICE Cookie:", self.cookie
      f.close()
    except:
      self.error = "Impossible de recuperer le cookie d'ALICE"
      print "### ALICE", self.error
  
  def process(self, bouchot, context, post=None):
    try:
      text = post.message
      if not self.cookie:
        self.getcookie()
      if self.cookie:
        c_name, c_val = self.cookie.split('=')
      query = urllib.urlencode({c_name: c_val, 'input': text[text.find('<'):]})
      f = open_url(self.bot_server, self.bot_url, self.pycc.options, cookie=self.cookie, data=query)
      res = f.read()
      f.close()
      print "### ALICE response"
      print res
      #end = res.find("<FORM name=f action", 0)
      #print "### ALICE", end
      start = res.rfind("<em>")+4
      end = res.find("</em>", start)
      print "### ALICE", start, end, res[start:end]
    except:
      self.error = "Erreur rseau ou du serveur ALICE"
      print "### ALICE", self.error
      return
    try:
      topost = unicode(res[start.end]).encode(bouchot.trib.options.val('encoding'))
    except:
      topost = res[start:end]
    try:
      bouchot.trib.poster("%s %s" % (post.dispTimeRef(), topost), 1, Identity(login="Alice", ua="Alice"))
    except:
      self.error = "Impossible de poster dans le bouchot %s" % bouchot.name
      print "### ALICE", self.error
  
  
class Cybelle(Plugin):
  
  def init(self):
    self.bot_server = "www.agentland.fr"
    self.bot_url = "/cgi-bin/Alice/prod-cybelle.fr.cgi"
    self.cookie = ""
    self.session = ""
    # self.getsession()
  
  def getsession(self):
    try:
      f = open_url(self.bot_server, self.bot_url, self.pycc.options)
      self.cookie = f.info().getheader('Set-Cookie').split(";")[0]
      res = f.read()
      print res
      start = res.find('<INPUT TYPE="hidden" NAME="session" VALUE="')
      end = res.find('"', start+44)
      self.session = res[start+43:end]
      print "### CYBELLE Cookie: ", self.cookie
      print "### CYBELLE Session:", self.session
      f.close()
      # On fait une premire requte pour viter la question bte "comment tu t'appelles"
      query = urllib.urlencode({'text': 'tribune', 'session': self.session, 'virtual': '<client_id>'})
      f = open_url(self.bot_server, self.bot_url, self.pycc.options, cookie=self.cookie, data=query)
      f.close()
    except:
      self.error = "Impossible d'initialiser la conversation avec CYBELLE"
      print "### CYBELLE", self.error
  
  def process(self, bouchot, context, post=None):
    if not self.session:
      self.getsession()
    try:
      text = post.message.encode(bouchot.trib.options.val('encoding'))
    except:
      print "kikooooooo"
      text = post.message
    try:
      if self.cookie:
        c_name, c_val = self.cookie.split('=')
      query = urllib.urlencode({'text': text[text.find('<'):], 'session': self.session, 'virtual': '<client_id>'})
      f = open_url(self.bot_server, self.bot_url, self.pycc.options, cookie=self.cookie, data=query)
      res = f.read()
      f.close()
      print "### CYBELLE response"
      print res
      #end = res.find("<FORM name=f action", 0)
      #print "### ALICE", end
      end = res.rfind("</small>")
      start = res[:end].rfind("<small>")+7
      msg = res[start:end]
      start = msg.find("<script")
      end = 0
      toto = ""
      while start >= 0:
        toto += msg[end:start]
        end = msg.find("</script", start)
        end += 9
        start = msg.find("<script", end)
      toto += msg[end:]
      print "### CYBELLE", start, end, toto
    except:
      self.error = "Erreur rseau ou du serveur CYBELLE"
      print "### CYBELLE", self.error
      return
    try:
      topost = zapEntities(toto.replace("\n", " "), bouchot.trib.options.val('encoding'))
    except:
      topost = toto
    try:
      bouchot.trib.poster("%s %s" % (post.dispTimeRef(), topost), 1, Identity(login="Cybelle", ua="Cybelle"))
    except:
      self.error = "Impossible de poster dans le bouchot %s" % bouchot.name
      print "### CYBELLE", self.error
    