# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module PhpMyChat
##   Ce module contient le plug-in phpmychat, permettant d'utiliser pycc
##   comme client de chat sur des salons tournant sous phpmychat.
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')

from constants import *
from coinlib.plugin import *
from coinlib.persistants import Option, OptionSet
from cointklib.dialogs import OptionsDialog
from cointklib.widgets import OptionsEditor

import urllib, md5

def build_plugins(pycc):
  return { \
    'phpmychat': PhpMyChat(pycc, "PhpMyChat", "Pour se connecter a un serveur phpmychat")
  }

class PhpMyChatOptions(OptionSet):
  def setName(self, name):
    self.name = "PhpMyChat"
  
  def setObjects(self):
    self._objects = {
      'pmc_login':   Option("Votre pseudo", value=""),
      'pmc_passwd':  Option("Mot de passe (si authentifi)", value=""),
      'pmc_lang':    Option("Langage", value="french"),
      'pmc_room':    Option("Salon", value=""),
      'pmc_connect': Option("Envoyer la requete de connexion", value=1, type=TYPE_BOOL),
      'toedit':      Option("Editables", { \
          "Gnral": [ 'pmc_login', 'pmc_passwd', 'pmc_lang', 'pmc_room', 'pmc_connect' ]
        } )
    }


class PhpMyChat(Plugin):
  
  def load_config(self):
    self.options = PhpMyChatOptions(path=self.config_path)
  
  def config_frame(self, master):
    return OptionsEditor(master, self.options, self.pycc)
  
  def action_menu(self):
    # Boite de config pour la connexion
    #if self.options.val('pmc_login') == "":
    #  self.options.set('pmc_login', trib.options.get('user_login').get())
    
    cur_trib = self.pycc.bouchots[self.pycc.get_bouchot()].trib
    if cur_trib is None or not cur_trib.loaded: return
    
    self.pycc.root.canceled = 1
    OptionsDialog("PhpMyChat", self.pycc.root, self.options, self.pycc)
    if self.pycc.root.canceled:
      return
    
    # Mise  jour des options
    # print "### maj des options"
    pwd_hash = md5.new(self.options.val('pmc_passwd')).hexdigest()
    post_data = 'From=../index.php3&Ver=H&T=1&D=10&N=5&O=1&ST=1&NT=1&L=%s&U=%s&R=%s&PWD_Hash=%s&M=%%m' % (
       self.options.val('pmc_lang'), self.options.val('pmc_login'), self.options.val('pmc_room'), pwd_hash )
    cur_trib.options.set('add_post_data', post_data)
    #trib.options.set('user_login', self.options.val('pmc_login'))
    backend = cur_trib.options.val('backend')
    pos = backend.find('?')
    if pos == -1:
      pos = len(backend)
    backend = backend[:pos] + "?L=%s&R=%s&U=%s" % (self.options.val('pmc_lang'), self.options.val('pmc_room'), self.options.val('pmc_login'))
    cur_trib.options.set('backend', backend)
    
    # Tentative de connexion au chat
    if self.options.val('pmc_connect'):
      # print "### tentative de connexion au chat"
      server = cur_trib.bouchot.options.val('http_server')
      url = "/index.php3"
      data = urllib.urlencode( { 'Ver': 'L', 'Form_Send': '1', 'N': '5', 'D': '10',
        'L': self.options.val('pmc_lang'), 'U': self.options.val('pmc_login'),
        'PASSWORD': self.options.val('pmc_passwd'), 'R0': self.options.val('pmc_room') } )
      try:
        f = open_url(server, url, cur_trib.bouchot.pycc.options, "pyCoinCoin/"+PYCC_VERSION, "", data)
        res = f.read()
        f.close()
        print res
      except:
        print "### RATAI"
    
    # Restart du thread tribune, pour rafraichissement immdiat
    # print "### restart tribune"
    cur_trib.thread.restart()

  
  def process(self, bouchot, context, post=None):
    pass
