# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module WoofPark
##   Ce module dfinit le plug-in WoofPark : affichage des trombines
##   des moules version SouthPark en fonction du pseudo, rcupres
##   sur http://sveetch.net/html/Woof_Park.html
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from coinlib.baseclasses import Post

import re
from Tkinter import *
import tkSimpleDialog

def build_plugins(pycc):
  return { \
    'woofpark': WoofPark(pycc, "WoofPark", "Affiche la trombine style Southpark du posteur")
  }

class WoofPark(Plugin):
  
  def init(self):
    self.park = ""
    self.popup_on = 0
  
  def getWoofPark(self):
    try:
      f = open_url("sveetch.net", "/html/Woof_Park.html", self.pycc.options)
      self.park = f.read()
      f.close()
    except:
      self.park = ""
      self.error = "Erreur rseau ou du serveur sveetch.net"
      log.error(self.error)
  
  def popup_destroy(self, popup):
    popup.destroy()
    self.popup_on = 0
  
  def popup_zoom(self, popup, bouchot, post, zoom):
    self.popup_destroy(popup)
    self.process(bouchot, "PINNI", post, 1-zoom)
  
  def action_menu(self):
    res = tkSimpleDialog.askstring("WoofPark", "Entrer un login/pseudo:", parent=self.pycc.root)
    if res is not None:
      dummypost = Post('0', login=res)
      self.process(self.pycc.bouchots[self.pycc.get_bouchot()], "PINNI", dummypost)
  
  def process(self, bouchot, context, post=None, zoom=0):
    if self.popup_on:
      return
    if zoom:
      imgtype = "popup_"
    else:
      imgtype = "image_"
    imgname = "woofpark_"+imgtype+post.login
    if not bouchot.pycc.images.has_key(imgname):
      if not self.park:
        self.getWoofPark()
      regexp = ".*(http[:][/][/]sveetch.net.*"+imgtype+post.login.lower()+".jpg).*"
      myre = re.compile(regexp)
      for line in self.park.split():
        res = myre.match(line)
        if res is not None: break
      if not res:
        self.error = "Pas d'image trouve pour " + post.login
        return
      imgurl = res.groups()[0]
      imgfile = bouchot.pycc.getImageWithCache(imgurl)
      bouchot.pycc.images[imgname] = get_image(imgfile)
    popimg = Label(bouchot.trib.pinni.root, image=bouchot.pycc.images[imgname], border=2, relief='raised')
    popimg.bind("<ButtonRelease-1>", lambda e, pop=popimg, s=self: s.popup_destroy(pop))
    popimg.bind("<ButtonRelease-3>", lambda e, pop=popimg, s=self, b=bouchot, p=post: s.popup_zoom(pop,b,p,zoom))
    popimg.place(in_=bouchot.trib.pinni._pinni, x=0, y=0)
    self.popup_on = 1
  